/*
 * pg_unac.c
 *
 * Author: Nhan NGO DINH
 * Version: 1.0
 * Description: PostgreSQL external function
 *   unaccent the given string
 *
 */

#include <stdio.h>
#include <postgres.h>
#include <string.h>
#include <fmgr.h>
#include <unac.h>

PG_FUNCTION_INFO_V1(unac);

Datum unac(PG_FUNCTION_ARGS) {

  text *str = PG_GETARG_TEXT_P(0);
  text *result;
  
  int tlen, nlen, dlen;
  char *tstr, *nstr;
  
  tlen = VARSIZE(str) - VARHDRSZ;
  tstr = (char *) malloc(tlen + 1);
  memcpy(tstr, VARDATA(str), tlen);
  tstr[tlen] = '\0';

  nstr = NULL; nlen = 0;
  unac_string("UTF-8", tstr, strlen(tstr), &nstr, &nlen);
  dlen = nlen - tlen;

  result = (text *) malloc(VARSIZE(str));
  memcpy(VARDATA(result), nstr, strlen(nstr));
  VARATT_SIZEP(result) = VARSIZE(str) + dlen;
  
  PG_RETURN_TEXT_P(result);
  
}
